# 适用于SL-7500C的OpenZaurus Keymap

由于OpenZaurus只有适用于SL-C700的版本，在中国版SL-7500C上键盘映射是乱的，给使用带来了很大的不便。

幸运的是，这个版本的内核，支持从`/etc/keymap-2.6.map`文件加载键盘映射，因此，只需要替换`/etc/keymap-2.6.map`为本仓库内的`keymap-2.6.map`文件即可修复键盘映射问题。

值得注意的是，本人编写的这个keymap文件并不是完全按照SL-7500C键盘所印制的字样制作的，有少量的区别，但不难记忆。

如果您有什么其他的需要，可以自行修改。本人暂不对提供的Keymap进行任何额外的技术支持。

## 使用说明

以OpenZaurus + OPIE为例。

### 下载

您可以通过git克隆整个仓库：

```bash
git clone http://git.swzry.com/PlayWithSharpZaurus/openzaurus-keymap4sl-7500c`
```
git的具体使用方法在这里不再赘述，请查阅相关文档。

您也可以直接下载该文件，具体操作也不再赘述。

### 拷贝到Zaurus

您可以把文件拷贝到CF卡、SD卡中，或者也可以用其他方式。

以下以Zaurus SL-7500C机器，OpenZaurus + OPIE环境，使用CF卡拷贝为例。

1. 拷贝`keymap-2.6.map`到CF卡中。
2. 在Application中找到Console应用程序，也就是终端。
3. 备份原本的`keymap-2.6.map`文件，并拷贝CF卡中的新文件替换它。

```bash
cd /etc/
mv ./keymap-2.6.map ./keymap-2.6.map.bak
cp /mnt/cf/keymap-2.6.map ./
```

4. 在Settings中找到Shutdown应用程序，然后进行Reboot操作。
5. 机器重启后，新的键盘映射便生效了。

## 与键盘印字的区别

### 修改的映射

* 左下角，Fn键旁边的`;`分号键，作为Ctrl键使用；`'`单引号键，作为Alt键使用。
* 输入分号`;`，使用Fn + `,`
* 输入冒号`:`，使用Fn + `N`
* 输入单引号`'`，使用Fn + `.`
* 输入双引号`"`，使用Fn + `M`

### 未实现的映射

* 未实现Fn + `E`输入欧元符号的功能
* 未实现Fn + `R`输入英镑符号的功能
* 未实现Fn + `1` ~ `6`的多媒体按键功能
* 未实现Fn + `BS` 的 `DEL`键功能
* 未实现Fn + `X` / `C` / `V` 的剪切、复制、粘贴功能

## 关于这些问题的解释

### 修改的映射

由于对于OpenZaurus + OPIE的使用环境下，我认为`Ctrl`键和`Alt`键是很有必要的。

在原本SL-C700的键盘映射，工作在SL-7500C上，`;`就映射为了`Ctrl`，而`'`映射为了`Alt`。
而且这两个按键的位置也符合大家对于PC键盘的习惯，于是我决定对此不作修改。

为了能够输入`;` `:` `'` `"`这四个符号，我参考了PC键盘上的位置，利用Fn键，\
分别映射到了Fn + `,` / `.` / `N` / `M` 上，由于较为符合PC键盘上的相对位置，因而也不难记忆。

### 未实现的映射

#### 英镑和欧元符号

由于在原本的keymap中我未能找到欧元符号和英镑符号的code名称，
且我也暂时没有精力去进一步研究，
再加上对于中国人的日常使用而言这两个符号并不重要，
因此我就没有去实现这两个键的映射。

#### 多媒体键

我尚不清楚多媒体键应该使用什么样的code来实现，因而暂未实现。

#### DEL键

事实上原版Keymap中已经定义了Fn + `BS`为`DEL`，但实际在文本编辑器内测试并不起作用。

我保留了原版的这个映射未作修改，但事实上，它不起作用。

也许在某些场合下会起作用吧，至少文本编辑器里不行。

先这样。

#### 剪切、复制、粘贴

由于已经有了`Ctrl`键（即印有`;`的按键），重复地映射Fn +  `X` / `C` / `V` 没有必要，在支持的应用程序里，可以直接使用熟悉的`Ctrl + X` `Ctrl + C` `Ctrl + V`完成这些操作。

## 测试环境

本人在以下环境测试了该Keymap：

* Zaurus SL-7500C，硬件版本V1.0.6 CN
* Linux Kernel Version 2.6.16-3.5.4.1 Compiled by tota@openzarus-ja
* OpenZaurus Version 3.5.4.1 With Model SL-C750, Vendor: OpenZaurus Team
* Opie Version 1.2.1, Built against Qt/E 2.3.10, Built on Jul 8 2006
